C Makes a susy spectrum from a herwig susy input file.
C Needs to link to HWISSP
C Produces a topdrawer input file
C     
C     
      program spectrum
      include 'HERWIG65.INC'
      integer issp,i,idau,jdaugood,prdgood
      character *80 susyfile,outfile
      character *10 color
      CHARACTER *1 CQUARK(6)
      DATA CQUARK/'d','u','s','c','b','t'/
      integer maxsusy,spout
      parameter (maxsusy=60)
      parameter (spout=60)
      real ptype(maxsusy)
      real maxmass
      real brfracadd, brfracmin, brfracsolid, brfracdash

      real xtxt,xl,xr,ytxt,xmax,ymax,len,xplot
      xmax=7.
      len=0.6            ! particle line length
      brfracmin=0.001    ! Min BR for join with dots
      brfracdash=0.01    ! Min BR for join with dashes
      brfracsolid=0.1    ! Min BR for join solid
      brfracadd=0.1      ! Min BR to add new particle if desired

      WRITE(*,*)'Enter Filename in single quotes'
      READ(*,*) SUSYFILE
      WRITE(*,*)'Opening: ',SUSYFILE

      LRSUSY=56
      OPEN(UNIT=LRSUSY,STATUS='OLD',FILE=SUSYFILE)
      CALL HWISSP(LRSUSY)
      CLOSE(UNIT=LRSUSY)
      DO i=1,maxsusy
         ptype(i)=0
      enddo

CC   ptype tells the program where on the x-axis to plot that particle
CC   If ptype==0 the particle is not plotted.
CC   If ptype is negative then it is only plotted if it is a 
CC   decay product of other plotted particles, with branching fraction
CC   greater than 'brfracadd'

CC   [Herwig codes for particles minus 400]

CC     L squarks:
      ptype(1)=2 ! D
      ptype(2)=2 ! U
      ptype(5)=1.5 ! B1
      ptype(6)=2.5 ! T1
CC     R squarks:
      ptype(13)=4.5 ! D
      ptype(14)=4.5 ! U
      ptype(17)=6.0 ! B2
      ptype(18)=6.2 ! T2
CC     Gluino
      ptype(49)=4.25 ! 
CC     Sleptons
      ptype(25)=1.5 ! EL
      ptype(29)=-5.5 ! TAU1 
      ptype(37)=1.5 ! ER
CC     Neutralinos
      ptype(50)=5.0 ! N1
      ptype(51)=6.5 ! N2
      ptype(52)=0.0 ! N3
      ptype(53)=0.0 ! N4
      ptype(54)=3   ! C1+
      ptype(55)=0   ! C2+
      ptype(56)=3   ! C1-
      ptype(57)=0.0 ! C2-
c      if(rmass(458).lt.1000) then
         ptype(58) = -4.
c      else
c         ptype(58)=-1
c      endif
CC Don't put on names for anti-particles:
      RNAME(456)=''
      RNAME(457)=''

 100  maxmass=0.
      DO i=1,maxsusy
         issp=400+i
         if (ptype(i).gt.0.and.
     &        RMASS(issp).gt.maxmass) then
            maxmass=RMASS(issp)
         endif
      enddo
      ymax=maxmass*1.1
      
      OPEN(UNIT=SPOUT,FILE='spectrum.top')

      WRITE(SPOUT,990)xmax,ymax
 990  FORMAT('SET LIMITS X 1.1 ',f16.8,' Y 0. ',f16.8)
      WRITE(SPOUT,*)'SET FONT DUPLEX'
      WRITE(SPOUT,*)'SET GRID Y DOTS'
      WRITE(SPOUT,*)'SET SIZE 15 15'
      WRITE(SPOUT,*)'SET AXES LEFT ON RIGHT OFF X OFF'
      WRITE(SPOUT,*)'SET TITLE SIZE 3'

C     Draw the decay lines first...

C     loop through all herwig decays, looking for ones between
C     particles we are interested in:
      do i=1,NMXDKS
         if (idk(i).gt.400.and.idk(i).le.400+maxsusy) then
            if (ptype(idk(i)-400).gt.0) then
               jdaugood=0
               prdgood=0
               do idau=1,5
                  if (idkprd(idau,i).gt.400.and.
     &                 idkprd(idau,i).le.400+maxsusy) then
                     if (BRFRAC(i).gt.brfracmin) then
                        if(ptype(idkprd(idau,i)-400).gt.0 ) then
                           jdaugood=idau
                           prdgood=idkprd(idau,i)
                        elseif(BRFRAC(i).gt.brfracadd.and.
     &                          ptype(idkprd(idau,i)-400).lt.0) then
                           ptype(idkprd(idau,i)-400)=
     &                          abs(ptype(idkprd(idau,i)-400))
                           write(*,*)'Added ',RNAME(idkprd(idau,i))
                           CLOSE(SPOUT)
                           goto 100
                        endif
                      endif
                  endif
               enddo
               if (jdaugood.ne.0) then
                  write(SPOUT,1020)ptype(idk(i)-400),RMASS(idk(i))
                  write(SPOUT,1020)ptype(prdgood-400),RMASS(prdgood)
 1020             FORMAT(f6.3,1x,f6.0)


                  COLOR='magenta'
                  if (((idk(i).ge.401.and.idk(i).le.424)
     &                 .or.idk(i).eq.449).and.(
     &                 (idkprd(jdaugood,i).ge.401.and.
     &                 idkprd(jdaugood,i).le.424)
     &                 .or.idkprd(jdaugood,i).eq.449)) then
                     color='blue'
                  else if((idk(i).ge.401.and.idk(i).le.424)
     &                 .or.idk(i).eq.449) then
                     color='red'
                     if(idkprd(jdaugood,i).eq.450) color='green'
                  else if(idkprd(jdaugood,i).eq.450) then 
                     color ='cyan'
                  endif



                  if(BRFRAC(i).gt.brfracsolid) then
                     write(SPOUT,*)'JOIN ',COLOR
                  elseif(BRFRAC(i).gt.brfracdash) then
                     write(SPOUT,*)'JOIN DASH ',COLOR
                  elseif(BRFRAC(i).gt.brfracmin) then
                      write(SPOUT,*)'JOIN DOTS ',COLOR
                  endif

C                  write(*,1030)rname(idk(i)),RNAME(prdgood),
C     &                 BRFRAC(i)
 1030             FORMAT(a8,' -> ',a8,2x,f6.4) 
               endif
            endif
         endif
      enddo

C     Now do the particles!
      DO i=1,maxsusy
         issp=400+i
         if (ptype(i).le.0.) goto 2000
         xl=ptype(i)-len/2
         xr=ptype(i)+len/2
         WRITE(SPOUT,*)xl,RMASS(issp)
         WRITE(SPOUT,*)xr,RMASS(issp)
         WRITE(SPOUT,*)'JOIN WIDTH=2'
C--neutralinos
         IF(ISSP.GE.450.AND.ISSP.LE.453) THEN
            WRITE(SPOUT,2010) XR+len/10.0D0,RMASS(ISSP),ISSP-449
 2010       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"C0451~2460',I1,'12203"; CASE "GUUUV VVUX XUX X"')
C--charginos
         ELSEIF(ISSP.GE.454.AND.ISSP.LE.455) THEN
            WRITE(SPOUT,2020) XR+len/10.0D0,RMASS(ISSP),ISSP-453
 2020       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"C0451~2460',I1,'122+3";CASE "GUUUV VVUX XUX X"')
C--gluino
         ELSEIF(ISSP.EQ.449) THEN
            WRITE(SPOUT,2030) XR+len/10.0D0,RMASS(ISSP)
 2030       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"g061~"; CASE " UUV "')
C--left  squarks
         ELSEIF(ISSP.LE.404) THEN
            IF(MOD(ISSP,2).EQ.1) THEN 
               xplot = xr+len/10.0D0
            else
               xplot = xl-len/5.
            endif
            IF(ISSP.EQ.401) THEN
               WRITE(SPOUT,2040) XPLOT,RMASS(ISSP),CQUARK(ISSP-400)
 2040          FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &              '"',A1,'0413~240L1"; CASE " UUVV VVX X"')
            ELSE
               WRITE(SPOUT,2041) XPLOT,RMASS(ISSP),CQUARK(ISSP-400)
 2041          FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &              '"',A1,'041~20L1"; CASE " UUV VX X"')
            ENDIF
         ELSEIF(ISSP.EQ.405.OR.ISSP.EQ.406) THEN
            IF(MOD(ISSP,2).EQ.1) THEN 
               xplot = xr+len/10.0D0
            else
               xplot = xl-len/6.
            endif
            WRITE(SPOUT,2042) XPLOT,RMASS(ISSP),CQUARK(ISSP-400)
 2042       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"',A1,'0413~24011"; CASE " UUVV VVX X"')
C--right squarks
         ELSEIF(ISSP.GE.413.AND.ISSP.LE.416) THEN
            IF(MOD(ISSP,2).EQ.1) THEN 
               xplot = xr+len/10.0D0
            else
               xplot = xl-len/5.
            endif
            IF(ISSP.EQ.413) THEN
               WRITE(SPOUT,2050) XPLOT,RMASS(ISSP),CQUARK(ISSP-412)
 2050          FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &              '"',A1,'0413~240R1"; CASE " UUVV VVX X"')
            ELSE
               WRITE(SPOUT,2051) XPLOT,RMASS(ISSP),CQUARK(ISSP-412)
 2051          FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &              '"',A1,'041~20R1"; CASE " UUV VX X"')
            ENDIF
         ELSEIF(ISSP.EQ.417.OR.ISSP.EQ.418) THEN
            IF(MOD(ISSP,2).EQ.1) THEN 
               xplot = xr+len/10.0D0
            else
               xplot = xl-len/6.
            endif
            WRITE(SPOUT,2043) XPLOT,RMASS(ISSP),CQUARK(ISSP-412)
 2043       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"',A1,'0413~24021"; CASE " UUVV VVX X"')
         ELSEIF(ISSP.EQ.429) THEN
            xplot=xr+len/10.
            WRITE(SPOUT,2052) XPLOT,RMASS(ISSP),'T'
 2052       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"',A1,'0413~24011"; CASE "GUUVV VVX X"')
         ELSEIF(ISSP.EQ.425) THEN
            xplot = xr+len/10.
            WRITE(SPOUT,2041) XPLOT,RMASS(ISSP),'e'
         ELSEIF(ISSP.EQ.437) THEN 
            xplot = xr+len/10.
            WRITE(SPOUT,2050) XPLOT,RMASS(ISSP),'e'
         ELSEIF(ISSP.EQ.458) THEN
            xplot  = xr+len/10.
            WRITE(SPOUT,2053) XPLOT,RMASS(ISSP),'G'
 2053       FORMAT('TITLE DATA SIZE=2.',f8.3,1x,f8.3,1x,
     &           '"',A1,'0413~24"; CASE " UUVV VV"')
C--right squarks
         ELSE
            WRITE(SPOUT,1000)xr,RMASS(issp),RNAME(issp)
 1000       FORMAT('TITLE DATA SIZE=2.',
     &           f8.3,1x,f8.3,1x,'"',a8,'"')
         ENDIF
         WRITE(*,1010)issp,RNAME(issp),RMASS(issp)
 1010    FORMAT(i4,1x,a8,1x,f7.0)
 2000 enddo
      
      
      
      ClOSE(SPOUT)
      return
      end

***************************
      subroutine hwanal
      return 
      end
***************************
      subroutine hwaend
      return
      end
**************************
      subroutine hwabeg
      return
      end
**************************
