## scan.gnu
## example gnuplot input file to produce m0/m12 parameter plots

## set the axes
set xrange [0:2100]
set yrange [0:2100]
set zrange [*:*]
set xlabel "m0"
set ylabel "m12"

## the datafile uses 'x' for missing values
set datafile missing "x"

## this sets the plot format
set pm3d at bs flush end ftriangles hidden3d 100
set style line 100 lt 6 lw 0.5
set data style pm3d

## uncomment here to get contour plots
#set view map

###########
###########

## label the z-axis
set zlabel "mh0"

## plot the data in file data03.dt using columns 3, 4 and 8
## columns 3 and 4 contain the parameters m0 and m1/2
## column 8 contains m_h0 (see HELP file)
splot "data03.dt" using 3:4:8 

## wait for 'enter'
pause -1

### use a construction like this to only plot points from 
### column 24 (top1) when column 8 (the higgs) is greater than 114:
#
#set zlabel "mt1"
#splot "data03.dt" using 3:4:($8>114 ? $24 : 1/0)
#pause -1
#
## more complicated tests are possible:
## ($29<$12 && $8<114 ? $24 : 1/0) plots top1 if
## stau1 is lighter than neut1 AND higgs < 114

set zlabel "mH0"
splot "data03.dt" using 3:4:9 
pause -1

set zlabel "mneut1"
splot "data03.dt" using 3:4:12
pause -1

set zlabel "mt1"
splot "data03.dt" using 3:4:24
pause -1

set zlabel "mtau1"
splot "data03.dt" using 3:4:29
pause -1

##############
##############
set zlabel "mh0"
splot "data30.dt" using 3:4:8 
pause -1

set zlabel "mH0"
splot "data30.dt" using 3:4:9 
pause -1

set zlabel "mneut1"
splot "data30.dt" using 3:4:12
pause -1

set zlabel "mt1"
splot "data30.dt" using 3:4:24
pause -1

set zlabel "mtau1"
splot "data30.dt" using 3:4:29
pause -1

##############
##############

set zlabel "mh0"
splot "data45.dt" using 3:4:8
pause -1

set zlabel "mH0"
splot "data45.dt" using 3:4:9 
pause -1

set zlabel "mneut1"
splot "data45.dt" using 3:4:12
pause -1

set zlabel "mt1"
splot "data45.dt" using 3:4:24
pause -1

set zlabel "mtau1"
splot "data45.dt" using 3:4:29
pause -1


#########
#########
